/*
 *
 *  ĥ饤֥
 *
 *  Copyright 1990-1999 Matsushita Soft-Research, INC. A.Takuma
 *
 *  System      : Kanji External Library
 *  Sub system  : library routine
 *  File        : kanjiext.c
 *  Version     : 2.20
 *  First Edit  : 1990-11/01
 *  Last  Edit  : 1999-12/15
 *  Author      : MSRS3  
 *
 */

#include	<stdio.h>
#include	<ctype.h>
#ifdef	__STDC__
#include	<stdarg.h>
#else	/* !__STDC__ */
#include	<varargs.h>
#endif	/* !__STDC__ */
#include	"kanjilib.h"
#include	"kanjiext.h"

int	kana_cnv_mode = 0;		/* Ҳ̾Ѵ⡼	*/

struct translate	trans_data[] = {
  {"a",    "\244\242",          "\245\242"},    /* "",   ""         */
  {"i",    "\244\244",          "\245\244"},    /* "",   ""         */
  {"u",    "\244\246",          "\245\246"},    /* "",   ""         */
  {"e",    "\244\250",          "\245\250"},    /* "",   ""         */
  {"o",    "\244\252",          "\245\252"},    /* "",   ""         */
  {"ka",   "\244\253",          "\245\253"},    /* "",   ""         */
  {"ki",   "\244\255",          "\245\255"},    /* "",   ""         */
  {"ku",   "\244\257",          "\245\257"},    /* "",   ""         */
  {"ke",   "\244\261",          "\245\261"},    /* "",   ""         */
  {"ko",   "\244\263",          "\245\263"},    /* "",   ""         */
  {"sa",   "\244\265",          "\245\265"},    /* "",   ""         */
  {"si",   "\244\267",          "\245\267"},    /* "",   ""         */
  {"su",   "\244\271",          "\245\271"},    /* "",   ""         */
  {"se",   "\244\273",          "\245\273"},    /* "",   ""         */
  {"so",   "\244\275",          "\245\275"},    /* "",   ""         */
  {"ta",   "\244\277",          "\245\277"},    /* "",   ""         */
  {"ti",   "\244\301",          "\245\301"},    /* "",   ""         */
  {"tu",   "\244\304",          "\245\304"},    /* "",   ""         */
  {"te",   "\244\306",          "\245\306"},    /* "",   ""         */
  {"to",   "\244\310",          "\245\310"},    /* "",   ""         */
  {"na",   "\244\312",          "\245\312"},    /* "",   ""         */
  {"ni",   "\244\313",          "\245\313"},    /* "",   ""         */
  {"nu",   "\244\314",          "\245\314"},    /* "",   ""         */
  {"ne",   "\244\315",          "\245\315"},    /* "",   ""         */
  {"no",   "\244\316",          "\245\316"},    /* "",   ""         */
  {"ha",   "\244\317",          "\245\317"},    /* "",   ""         */
  {"hi",   "\244\322",          "\245\322"},    /* "",   ""         */
  {"hu",   "\244\325",          "\245\325"},    /* "",   ""         */
  {"he",   "\244\330",          "\245\330"},    /* "",   ""         */
  {"ho",   "\244\333",          "\245\333"},    /* "",   ""         */
  {"ma",   "\244\336",          "\245\336"},    /* "",   ""         */
  {"mi",   "\244\337",          "\245\337"},    /* "",   ""         */
  {"mu",   "\244\340",          "\245\340"},    /* "",   ""         */
  {"me",   "\244\341",          "\245\341"},    /* "",   ""         */
  {"mo",   "\244\342",          "\245\342"},    /* "",   ""         */
  {"ya",   "\244\344",          "\245\344"},    /* "",   ""         */
  {"yi",   "\244\244",          "\245\244"},    /* "",   ""         */
  {"yu",   "\244\346",          "\245\346"},    /* "",   ""         */
  {"ye",   "\244\244\244\247",  "\245\244\245\247"},/* "", ""   */
  {"yo",   "\244\350",          "\245\350"},    /* "",   ""         */
  {"ra",   "\244\351",          "\245\351"},    /* "",   ""         */
  {"ri",   "\244\352",          "\245\352"},    /* "",   ""         */
  {"ru",   "\244\353",          "\245\353"},    /* "",   ""         */
  {"re",   "\244\354",          "\245\354"},    /* "",   ""         */
  {"ro",   "\244\355",          "\245\355"},    /* "",   ""         */
  {"la",   "\244\351",          "\245\351"},    /* "",   ""         */
  {"li",   "\244\352",          "\245\352"},    /* "",   ""         */
  {"lu",   "\244\353",          "\245\353"},    /* "",   ""         */
  {"le",   "\244\354",          "\245\354"},    /* "",   ""         */
  {"lo",   "\244\355",          "\245\355"},    /* "",   ""         */
  {"wa",   "\244\357",          "\245\357"},    /* "",   ""         */
  {"wi",   "\244\360",          "\245\360"},    /* "",   ""         */
  {"wu",   "\244\246",          "\245\246"},    /* "",   ""         */
  {"we",   "\244\361",          "\245\361"},    /* "",   ""         */
  {"wo",   "\244\362",          "\245\362"},    /* "",   ""         */
  {"nn",   "\244\363",          "\245\363"},    /* "",   ""         */
  {"n'",   "\244\363",          "\245\363"},    /* "",   ""         */
  {"fa",   "\244\325\244\241",  "\245\325\245\241"},/* "դ", "ե"   */
  {"fi",   "\244\325\244\243",  "\245\325\245\243"},/* "դ", "ե"   */
  {"fe",   "\244\325\244\247",  "\245\325\245\247"},/* "դ", "ե"   */
  {"fo",   "\244\325\244\251",  "\245\325\245\251"},/* "դ", "ե"   */
  {"fu",   "\244\325",          "\245\325"},    /* "",   ""         */
  {"xa",   "\244\241",          "\245\241"},    /* "",   ""         */
  {"xi",   "\244\243",          "\245\243"},    /* "",   ""         */
  {"xu",   "\244\245",          "\245\245"},    /* "",   ""         */
  {"xe",   "\244\247",          "\245\247"},    /* "",   ""         */
  {"xo",   "\244\251",          "\245\251"},    /* "",   ""         */
  {"xya",  "\244\343",          "\245\343"},    /* "",   ""         */
  {"xyu",  "\244\345",          "\245\345"},    /* "",   ""         */
  {"xyo",  "\244\347",          "\245\347"},    /* "",   ""         */
  {"xtu",  "\244\303",          "\245\303"},    /* "",   ""         */
  {"xtsu", "\244\303",          "\245\303"},    /* "",   ""         */
  {"xti",  "\244\306\244\243",  "\245\306\245\243"},/* "Ƥ", "ƥ"   */
  {"xdi",  "\244\307\244\243",  "\245\307\245\243"},/* "Ǥ", "ǥ"   */
  {"xdu",  "\244\311\244\245",  "\245\311\245\245"},/* "ɤ", "ɥ"   */
  {"xde",  "\244\307\244\247",  "\245\307\245\247"},/* "Ǥ", "ǥ"   */
  {"xdo",  "\244\311\244\251",  "\245\311\245\251"},/* "ɤ", "ɥ"   */
  {"xka",  "\244\253",          "\245\365"},    /* "",   ""         */
  {"xke",  "\244\261",          "\245\366"},    /* "",   ""         */
  {"ga",   "\244\254",          "\245\254"},    /* "",   ""         */
  {"gi",   "\244\256",          "\245\256"},    /* "",   ""         */
  {"gu",   "\244\260",          "\245\260"},    /* "",   ""         */
  {"ge",   "\244\262",          "\245\262"},    /* "",   ""         */
  {"go",   "\244\264",          "\245\264"},    /* "",   ""         */
  {"za",   "\244\266",          "\245\266"},    /* "",   ""         */
  {"zi",   "\244\270",          "\245\270"},    /* "",   ""         */
  {"zu",   "\244\272",          "\245\272"},    /* "",   ""         */
  {"ze",   "\244\274",          "\245\274"},    /* "",   ""         */
  {"zo",   "\244\276",          "\245\276"},    /* "",   ""         */
  {"da",   "\244\300",          "\245\300"},    /* "",   ""         */
  {"di",   "\244\302",          "\245\302"},    /* "",   ""         */
  {"du",   "\244\305",          "\245\305"},    /* "",   ""         */
  {"de",   "\244\307",          "\245\307"},    /* "",   ""         */
  {"do",   "\244\311",          "\245\311"},    /* "",   ""         */
  {"ba",   "\244\320",          "\245\320"},    /* "",   ""         */
  {"bi",   "\244\323",          "\245\323"},    /* "",   ""         */
  {"bu",   "\244\326",          "\245\326"},    /* "",   ""         */
  {"be",   "\244\331",          "\245\331"},    /* "",   ""         */
  {"bo",   "\244\334",          "\245\334"},    /* "",   ""         */
  {"va",   "\244\320\244\241",  "\245\364\245\241"},/* "Ф", ""   */
  {"vi",   "\244\320\244\243",  "\245\364\245\243"},/* "Ф", ""   */
  {"ve",   "\244\331\244\247",  "\245\364\245\247"},/* "٤", ""   */
  {"vo",   "\244\334\244\251",  "\245\364\245\251"},/* "ܤ", ""   */
  {"vu",   "\244\326",          "\245\364"},    /* "",   ""         */
  {"pa",   "\244\321",          "\245\321"},    /* "",   ""         */
  {"pi",   "\244\324",          "\245\324"},    /* "",   ""         */
  {"pu",   "\244\327",          "\245\327"},    /* "",   ""         */
  {"pe",   "\244\332",          "\245\332"},    /* "",   ""         */
  {"po",   "\244\335",          "\245\335"},    /* "",   ""         */
  {"ja",   "\244\270\244\343",  "\245\270\245\343"},/* "", ""   */
  {"ju",   "\244\270\244\345",  "\245\270\245\345"},/* "", ""   */
  {"je",   "\244\270\244\247",  "\245\270\245\247"},/* "", ""   */
  {"jo",   "\244\270\244\347",  "\245\270\245\347"},/* "", ""   */
  {"ji",   "\244\270",           "\245\270"},   /* "",   ""         */
  {"kya",  "\244\255\244\343",  "\245\255\245\343"},/* "", ""   */
  {"kyu",  "\244\255\244\345",  "\245\255\245\345"},/* "", ""   */
  {"kye",  "\244\255\244\247",  "\245\255\245\247"},/* "", ""   */
  {"kyo",  "\244\255\244\347",  "\245\255\245\347"},/* "", ""   */
  {"sha",  "\244\267\244\343",  "\245\267\245\343"},/* "", ""   */
  {"shu",  "\244\267\244\345",  "\245\267\245\345"},/* "", ""   */
  {"she",  "\244\267\244\247",  "\245\267\245\247"},/* "", ""   */
  {"sho",  "\244\267\244\347",  "\245\267\245\347"},/* "", ""   */
  {"sya",  "\244\267\244\343",  "\245\267\245\343"},/* "", ""   */
  {"shi",  "\244\267",          "\245\267"},    /* "",   ""         */
  {"syi",  "\244\267",          "\245\267"},    /* "",   ""         */
  {"syu",  "\244\267\244\345",  "\245\267\245\345"},/* "", ""   */
  {"sye",  "\244\267\244\247",  "\245\267\245\247"},/* "", ""   */
  {"syo",  "\244\267\244\347",  "\245\267\245\347"},/* "", ""   */
  {"tya",  "\244\301\244\343",  "\245\301\245\343"},/* "", ""   */
  {"tyi",  "\244\306\244\243",  "\245\301\245\243"},/* "Ƥ", ""   */
  {"tyu",  "\244\301\244\345",  "\245\301\245\345"},/* "", ""   */
  {"tye",  "\244\301\244\247",  "\245\301\245\247"},/* "", ""   */
  {"tyo",  "\244\301\244\347",  "\245\301\245\347"},/* "", ""   */
  {"tsa",  "\244\304\244\241",  "\245\304\245\241"},/* "Ĥ", "ĥ"   */
  {"tsi",  "\244\304\244\243",  "\245\304\245\243"},/* "Ĥ", "ĥ"   */
  {"tse",  "\244\304\244\247",  "\245\304\245\247"},/* "Ĥ", "ĥ"   */
  {"tso",  "\244\304\244\251",  "\245\304\245\251"},/* "Ĥ", "ĥ"   */
  {"tsu",  "\244\304",          "\245\304"},    /* "",   ""         */
  {"cha",  "\244\301\244\343",  "\245\301\245\343"},/* "", ""   */
  {"chu",  "\244\301\244\345",  "\245\301\245\345"},/* "", ""   */
  {"che",  "\244\301\244\247",  "\245\301\245\247"},/* "", ""   */
  {"cho",  "\244\301\244\347",  "\245\301\245\347"},/* "", ""   */
  {"chi",  "\244\301",          "\245\301"},    /* "",   ""         */
  {"nya",  "\244\313\244\343",  "\245\313\245\343"},/* "ˤ", "˥"   */
  {"nyu",  "\244\313\244\345",  "\245\313\245\345"},/* "ˤ", "˥"   */
  {"nye",  "\244\313\244\247",  "\245\313\245\247"},/* "ˤ", "˥"   */
  {"nyo",  "\244\313\244\347",  "\245\313\245\347"},/* "ˤ", "˥"   */
  {"hya",  "\244\322\244\343",  "\245\322\245\343"},/* "Ҥ", "ҥ"   */
  {"hyu",  "\244\322\244\345",  "\245\322\245\345"},/* "Ҥ", "ҥ"   */
  {"hye",  "\244\322\244\247",  "\245\322\245\247"},/* "Ҥ", "ҥ"   */
  {"hyo",  "\244\322\244\347",  "\245\322\245\347"},/* "Ҥ", "ҥ"   */
  {"mya",  "\244\337\244\343",  "\245\337\245\343"},/* "ߤ", "ߥ"   */
  {"myu",  "\244\337\244\345",  "\245\337\245\345"},/* "ߤ", "ߥ"   */
  {"mye",  "\244\337\244\247",  "\245\337\245\247"},/* "ߤ", "ߥ"   */
  {"myo",  "\244\337\244\347",  "\245\337\245\347"},/* "ߤ", "ߥ"   */
  {"rya",  "\244\352\244\343",  "\245\352\245\343"},/* "", ""   */
  {"ryu",  "\244\352\244\345",  "\245\352\245\345"},/* "", ""   */
  {"rye",  "\244\352\244\247",  "\245\352\245\247"},/* "ꤧ", "ꥧ"   */
  {"ryo",  "\244\352\244\347",  "\245\352\245\347"},/* "", ""   */
  {"lya",  "\244\352\244\343",  "\245\352\245\343"},/* "", ""   */
  {"lyu",  "\244\352\244\345",  "\245\352\245\345"},/* "", ""   */
  {"lye",  "\244\352\244\247",  "\245\352\245\247"},/* "ꤧ", "ꥧ"   */
  {"lyo",  "\244\352\244\347",  "\245\352\245\347"},/* "", ""   */
  {"pya",  "\244\324\244\343",  "\245\324\245\343"},/* "Ԥ", "ԥ"   */
  {"pyu",  "\244\324\244\345",  "\245\324\245\345"},/* "Ԥ", "ԥ"   */
  {"pye",  "\244\324\244\247",  "\245\324\245\247"},/* "Ԥ", "ԥ"   */
  {"pyo",  "\244\324\244\347",  "\245\324\245\347"},/* "Ԥ", "ԥ"   */
  {"gya",  "\244\256\244\343",  "\245\256\245\343"},/* "", ""   */
  {"gyu",  "\244\256\244\345",  "\245\256\245\345"},/* "", ""   */
  {"gye",  "\244\256\244\247",  "\245\256\245\247"},/* "", ""   */
  {"gyo",  "\244\256\244\347",  "\245\256\245\347"},/* "", ""   */
  {"zya",  "\244\270\244\343",  "\245\270\245\343"},/* "", ""   */
  {"zyu",  "\244\270\244\345",  "\245\270\245\345"},/* "", ""   */
  {"zye",  "\244\270\244\247",  "\245\270\245\247"},/* "", ""   */
  {"zyo",  "\244\270\244\347",  "\245\270\245\347"},/* "", ""   */
  {"dya",  "\244\302\244\343",  "\245\302\245\343"},/* "¤", "¥"   */
  {"dyi",  "\244\307\244\243",  "\245\307\245\243"},/* "Ǥ", "ǥ"   */
  {"dyu",  "\244\302\244\345",  "\245\302\245\345"},/* "¤", "¥"   */
  {"dye",  "\244\302\244\247",  "\245\302\245\247"},/* "¤", "¥"   */
  {"dyo",  "\244\302\244\347",  "\245\302\245\347"},/* "¤", "¥"   */
  {"bya",  "\244\323\244\343",  "\245\323\245\343"},/* "Ӥ", "ӥ"   */
  {"byu",  "\244\323\244\345",  "\245\323\245\345"},/* "Ӥ", "ӥ"   */
  {"bye",  "\244\323\244\247",  "\245\323\245\247"},/* "Ӥ", "ӥ"   */
  {"byo",  "\244\323\244\347",  "\245\323\245\347"},/* "Ӥ", "ӥ"   */
  {"kwa",  "\244\257\244\356",  "\245\257\245\356"},/* "", ""   */
  {"kwi",  "\244\257\244\243",  "\245\257\245\243"},/* "", ""   */
  {"kwe",  "\244\257\244\247",  "\245\257\245\247"},/* "", ""   */
  {"kwo",  "\244\257\244\251",  "\245\257\245\251"},/* "", ""   */
  {"kwu",  "\244\257",          "\245\257"},    /* "",   ""         */
  {"N",    "\244\363",          "\245\363"},    /* "",   ""         */
  {"0",    "\243\260",          "\243\260"},    /* "",   ""         */
  {"1",    "\243\261",          "\243\261"},    /* "",   ""         */
  {"2",    "\243\262",          "\243\262"},    /* "",   ""         */
  {"3",    "\243\263",          "\243\263"},    /* "",   ""         */
  {"4",    "\243\264",          "\243\264"},    /* "",   ""         */
  {"5",    "\243\265",          "\243\265"},    /* "",   ""         */
  {"6",    "\243\266",          "\243\266"},    /* "",   ""         */
  {"7",    "\243\267",          "\243\267"},    /* "",   ""         */
  {"8",    "\243\270",          "\243\270"},    /* "",   ""         */
  {"9",    "\243\271",          "\243\271"},    /* "",   ""         */
  {"z.",   "\241\304",          "\241\304"},    /* "",   ""         */
  {"z-",   "\241\301",          "\241\301"},    /* "",   ""         */
  {"z[",   "\241\330",          "\241\330"},    /* "",   ""         */
  {"z]",   "\241\331",          "\241\331"},    /* "",   ""         */
  {"zr",   "\241\271",          "\241\271"},    /* "",   ""         */
  {"zc",   "\241\273",          "\241\273"},    /* "",   ""         */
  {"zp",   "\242\251",          "\242\251"},    /* "",   ""         */
  {"z/",   "\241\246",          "\241\246"},    /* "",   ""         */
  {"+",    "\241\334",          "\241\334"},    /* "",   ""         */
  {"-",    "\241\274",          "\241\274"},    /* "",   ""         */
  {"!",    "\241\252",          "\241\252"},    /* "",   ""         */
  {"@",    "\241\367",          "\241\367"},    /* "",   ""         */
  {"#",    "\241\364",          "\241\364"},    /* "",   ""         */
  {"$",    "\241\360",          "\241\360"},    /* "",   ""         */
  {"%",    "\241\363",          "\241\363"},    /* "",   ""         */
  {"^",    "\241\260",          "\241\260"},    /* "",   ""         */
  {"&",    "\241\365",          "\241\365"},    /* "",   ""         */
  {"*",    "\241\366",          "\241\366"},    /* "",   ""         */
  {"(",    "\241\312",          "\241\312"},    /* "",   ""         */
  {")",    "\241\313",          "\241\313"},    /* "",   ""         */
  {"\\",   "\241\357",          "\241\357"},    /* "",   ""         */
  {"=",    "\241\341",          "\241\341"},    /* "",   ""         */
  {"<",    "\241\343",          "\241\343"},    /* "",   ""         */
  {">",    "\241\344",          "\241\344"},    /* "",   ""         */
  {",",    "\241\242",          "\241\242"},    /* "",   ""         */
  {".",    "\241\243",          "\241\243"},    /* "",   ""         */
  {"/",    "\241\277",          "\241\277"},    /* "",   ""         */
  {"?",    "\241\251",          "\241\251"},    /* "",   ""         */
  {"~",    "\241\261",          "\241\261"},    /* "",   ""         */
  {"\"",   "\241\311",          "\241\311"},    /* "",   ""         */
  {"\'",   "\241\307",          "\241\307"},    /* "",   ""         */
  {";",    "\241\250",          "\241\250"},    /* "",   ""         */
  {":",    "\241\247",          "\241\247"},    /* "",   ""         */
  {"{",    "\241\320",          "\241\320"},    /* "",   ""         */
  {"}",    "\241\321",          "\241\321"},    /* "",   ""         */
  {"[",    "\241\326",          "\241\326"},    /* "",   ""         */
  {"]",    "\241\327",          "\241\327"},    /* "",   ""         */
  {"|",    "\241\303",          "\241\303"},    /* "",   ""         */
  {"_",    "\241\262",          "\241\262"},    /* "",   ""         */
  {"`",    "\241\256",          "\241\256"},    /* "",   ""         */
  {" ",    "\241\241",          "\241\241"},    /* "",   ""         */
};

static struct jisx0208 {
  unsigned char	x0201;
  char		*x0208;
} jisx0208_data[] = {
  {' ',	   "\241\241"},			/* ""		*/
  {'+',	   "\241\334"},			/* ""		*/
  {'-',	   "\241\335"},			/* ""		*/
  {'!',	   "\241\252"},			/* ""		*/
  {'@',	   "\241\367"},			/* ""		*/
  {'#',	   "\241\364"},			/* ""		*/
  {'$',	   "\241\360"},			/* ""		*/
  {'%',	   "\241\363"},			/* ""		*/
  {'^',	   "\241\260"},			/* ""		*/
  {'&',	   "\241\365"},			/* ""		*/
  {'*',	   "\241\366"},			/* ""		*/
  {'(',	   "\241\312"},			/* ""		*/
  {')',	   "\241\313"},			/* ""		*/
  {'\\',   "\241\300"},			/* ""		*/
  {'=',	   "\241\341"},			/* ""		*/
  {'<',	   "\241\343"},			/* ""		*/
  {'>',	   "\241\344"},			/* ""		*/
  {',',	   "\241\244"},			/* ""		*/
  {'.',	   "\241\245"},			/* ""		*/
  {'/',	   "\241\277"},			/* ""		*/
  {'?',	   "\241\251"},			/* ""		*/
  {'~',	   "\241\261"},			/* ""		*/
  {'\"',   "\241\311"},			/* ""		*/
  {'\'',   "\241\307"},			/* ""		*/
  {';',	   "\241\250"},			/* ""		*/
  {':',	   "\241\247"},			/* ""		*/
  {'{',	   "\241\320"},			/* ""		*/
  {'}',	   "\241\321"},			/* ""		*/
  {'[',	   "\241\316"},			/* ""		*/
  {']',	   "\241\317"},			/* ""		*/
  {'|',	   "\241\303"},			/* ""		*/
  {'_',	   "\241\262"},			/* ""		*/
  {'`',    "\241\256"},			/* ""		*/
};

#ifdef	SUPPORT_X0201
static struct jisx0201 {
  char	*x0201;
  char	*x0208;
} jisx0201_data[] = {
  {"\216\266\216\336", "\245\254"},		/* ""	0	*/
  {"\216\267\216\336", "\245\256"},		/* ""		*/
  {"\216\270\216\336", "\245\260"},		/* ""		*/
  {"\216\271\216\336", "\245\262"},		/* ""		*/
  {"\216\272\216\336", "\245\264"},		/* ""		*/
  {"\216\273\216\336", "\245\266"},		/* ""	5	*/
  {"\216\274\216\336", "\245\270"},		/* ""		*/
  {"\216\275\216\336", "\245\272"},		/* ""		*/
  {"\216\276\216\336", "\245\274"},		/* ""		*/
  {"\216\277\216\336", "\245\276"},		/* ""		*/
  {"\216\300\216\336", "\245\300"},		/* ""	10	*/
  {"\216\301\216\336", "\245\302"},		/* ""		*/
  {"\216\302\216\336", "\245\305"},		/* ""		*/
  {"\216\303\216\336", "\245\307"},		/* ""		*/
  {"\216\304\216\336", "\245\311"},		/* ""		*/
  {"\216\312\216\336", "\245\320"},		/* ""	15	*/
  {"\216\313\216\336", "\245\323"},		/* ""		*/
  {"\216\314\216\336", "\245\326"},		/* ""		*/
  {"\216\315\216\336", "\245\331"},		/* ""		*/
  {"\216\316\216\336", "\245\334"},		/* ""		*/
  {"\216\312\216\337", "\245\321"},		/* ""	20	*/
  {"\216\313\216\337", "\245\324"},		/* ""		*/
  {"\216\314\216\337", "\245\327"},		/* ""		*/
  {"\216\315\216\337", "\245\332"},		/* ""		*/
  {"\216\316\216\337", "\245\335"},		/* ""		*/
  {"\216\263\216\336", "\245\364"},		/* ""	25	*/
  {"\216\240", "\241\241"},			/* ""		*/
  {"\216\241", "\241\243"},			/* ""		*/
  {"\216\242", "\241\326"},			/* ""		*/
  {"\216\243", "\241\327"},			/* ""		*/
  {"\216\244", "\241\242"},			/* ""		*/
  {"\216\245", "\241\246"},			/* ""		*/
  {"\216\246", "\245\362"},			/* ""		*/
  {"\216\247", "\245\241"},			/* ""		*/
  {"\216\250", "\245\243"},			/* ""		*/
  {"\216\251", "\245\245"},			/* ""		*/
  {"\216\252", "\245\247"},			/* ""		*/
  {"\216\253", "\245\251"},			/* ""		*/
  {"\216\254", "\245\343"},			/* ""		*/
  {"\216\255", "\245\345"},			/* ""		*/
  {"\216\256", "\245\347"},			/* ""		*/
  {"\216\257", "\245\303"},			/* ""		*/
  {"\216\260", "\241\274"},			/* ""		*/
  {"\216\261", "\245\242"},			/* ""		*/
  {"\216\262", "\245\244"},			/* ""		*/
  {"\216\263", "\245\246"},			/* ""		*/
  {"\216\264", "\245\250"},			/* ""		*/
  {"\216\265", "\245\252"},			/* ""		*/
  {"\216\266", "\245\253"},			/* ""		*/
  {"\216\267", "\245\255"},			/* ""		*/
  {"\216\270", "\245\257"},			/* ""		*/
  {"\216\271", "\245\261"},			/* ""		*/
  {"\216\272", "\245\263"},			/* ""		*/
  {"\216\273", "\245\265"},			/* ""		*/
  {"\216\274", "\245\267"},			/* ""		*/
  {"\216\275", "\245\271"},			/* ""		*/
  {"\216\276", "\245\273"},			/* ""		*/
  {"\216\277", "\245\275"},			/* ""		*/
  {"\216\300", "\245\277"},			/* ""		*/
  {"\216\301", "\245\301"},			/* ""		*/
  {"\216\302", "\245\304"},			/* ""		*/
  {"\216\303", "\245\306"},			/* ""		*/
  {"\216\304", "\245\310"},			/* ""		*/
  {"\216\305", "\245\312"},			/* ""		*/
  {"\216\306", "\245\313"},			/* ""		*/
  {"\216\307", "\245\314"},			/* ""		*/
  {"\216\310", "\245\315"},			/* ""		*/
  {"\216\311", "\245\316"},			/* ""		*/
  {"\216\312", "\245\317"},			/* ""		*/
  {"\216\313", "\245\322"},			/* ""		*/
  {"\216\314", "\245\325"},			/* ""		*/
  {"\216\315", "\245\330"},			/* ""		*/
  {"\216\316", "\245\333"},			/* ""		*/
  {"\216\317", "\245\336"},			/* ""		*/
  {"\216\320", "\245\337"},			/* ""		*/
  {"\216\321", "\245\340"},			/* ""		*/
  {"\216\322", "\245\341"},			/* ""		*/
  {"\216\323", "\245\342"},			/* ""		*/
  {"\216\324", "\245\344"},			/* ""		*/
  {"\216\325", "\245\346"},			/* ""		*/
  {"\216\326", "\245\350"},			/* ""		*/
  {"\216\327", "\245\351"},			/* ""		*/
  {"\216\330", "\245\352"},			/* ""		*/
  {"\216\331", "\245\353"},			/* ""		*/
  {"\216\332", "\245\354"},			/* ""		*/
  {"\216\333", "\245\355"},			/* ""		*/
  {"\216\334", "\245\357"},			/* ""		*/
  {"\216\335", "\245\363"},			/* ""		*/
  {"\216\336", "\241\253"},			/* ""		*/
  {"\216\337", "\241\254"},			/* ""		*/
};
#endif	/* SUPPORT_X0201 */

int	trans_size = sizeof(trans_data);

/*
 * EUC X0201X0208 1 ʸѴ
 * :ѴХȿ
 */

#ifdef	__STDC__
int	euc_han_to_zen1(char *ptr1, char *ptr2)
#else	/* !__STDC__ */
int	euc_han_to_zen1(ptr1, ptr2)
     char	*ptr1;
     char	*ptr2;
#endif	/* !__STDC__ */
{
  register int	i;

  if (((*ptr1 >= 'A') && (*ptr1 <= 'Z'))
      || ((*ptr1 >= 'a') && (*ptr1 <= 'z'))
      || ((*ptr1 >= '0') && (*ptr1 <= '9'))) {
    *((unsigned char*)ptr2++) = 0xa3;
    *ptr2++ = 0x80 | *ptr1;
    *ptr2 = '\0';
    return(1);						/* ѿ	*/
  }
#ifdef	SUPPORT_X0201
  if ((((unsigned char)*ptr1) == EUC_SS2) && kana_cnv_mode) {
    for (i = 0; i < sizeof(jisx0201_data) / sizeof(struct jisx0201); i++) {
      if (!strncmp(ptr1, (char*)jisx0201_data[i].x0201,
		   strlen((char*)jisx0201_data[i].x0201))) {
	strcpy(ptr2, jisx0201_data[i].x0208);
	return(strlen(jisx0201_data[i].x0201));		/* Ҳ̾	*/
      }
    }
  }
#endif	/* SUPPORT_X0201 */
  for (i = 0; i < sizeof(jisx0208_data) / sizeof(struct jisx0208); i++) {
    if (*ptr1 == jisx0208_data[i].x0201) {
      strcpy(ptr2, jisx0208_data[i].x0208);
      return(1);					/* 		*/
    }
  }
  *ptr2 = '\0';
  return(0);						/* ѴԲ	*/
}

/*
 * EUC X0201X0208 ʸѴ
 */

#ifdef	__STDC__
int	euc_han_to_zen(char *ptr1, char *ptr2)
#else	/* !__STDC__ */
int	euc_han_to_zen(ptr1, ptr2)
     char	*ptr1;
     char	*ptr2;
#endif	/* !__STDC__ */
{
  int	status;
  int	length;

  status = 0;
  *ptr2 = '\0';
  while (*ptr1) {
    length = euc_han_to_zen1(ptr1, ptr2);
    if (length) {
      ptr1 += length;;
      while (*ptr2) {
	ptr2++;
      }
    } else {
      status = 1;
      *ptr2++ = *ptr1++;
    }
  }
  *ptr2 = '\0';
  return(status);
}

/*
 * EUC X0208X0201 1 ʸѴ
 * :ѴХȿ
 */

#ifdef	__STDC__
int	euc_zen_to_han1(char *ptr1, char *ptr2)
#else	/* !__STDC__ */
int	euc_zen_to_han1(ptr1, ptr2)
     char	*ptr1;
     char	*ptr2;
#endif	/* !__STDC__ */
{
  register int	i;

  if (*ptr1 & 0x80) {
    if ((((unsigned char)*ptr1) == 0xa3) &&
	((((unsigned char)*(ptr1 + 1) >= (0x80 | 'A')) &&
	  ((unsigned char)*(ptr1 + 1) <= (0x80 | 'z'))) ||
	 (((unsigned char)*(ptr1 + 1) >= (0x80 | '0')) &&
	  ((unsigned char)*(ptr1 + 1) <= (0x80 | '9'))))) {
      *ptr2++ = *(ptr1 + 1) & 0x7f;
      *ptr2 = '\0';
      return(2);					/* ѿ	*/
    } else {
#ifdef	SUPPORT_X0201
      if (kana_cnv_mode) {
	for (i = 0; i < sizeof(jisx0201_data) / sizeof(struct jisx0201); i++) {
	  if (!strncmp(ptr1, jisx0201_data[i].x0208,
		       strlen(jisx0201_data[i].x0208))) {
	    strcpy(ptr2, jisx0201_data[i].x0201);
	    return(strlen(jisx0201_data[i].x0208));	/* Ҳ̾	*/
	  }
	}
      }
#endif	/* SUPPORT_X0201 */
      for (i = 0; i < sizeof(jisx0208_data) / sizeof(struct jisx0208); i++) {
	if (!strncmp(ptr1, jisx0208_data[i].x0208,
		     strlen(jisx0208_data[i].x0208))) {
	  *ptr2++ = jisx0208_data[i].x0201;
	  *ptr2 = '\0';
	  return(strlen(jisx0208_data[i].x0208));	/* 		*/
	}
      }
    }
  }
  *ptr2 = '\0';
  return(0);			/* ѴԲ or JIS-X0201 ϤΤޤ	*/
}

/*
 * EUC X0208X0201 ʸѴ
 */

#ifdef	__STDC__
int	euc_zen_to_han(char *ptr1, char *ptr2)
#else	/* !__STDC__ */
int	euc_zen_to_han(ptr1, ptr2)
     char	*ptr1;
     char	*ptr2;
#endif	/* !__STDC__ */
{
  int	status;
  int	length;

  status = 0;
  *ptr2 = '\0';
  while (*ptr1) {
    if (*ptr1 & 0x80) {
      length = euc_zen_to_han1(ptr1, ptr2);
      if (length) {
	ptr1 += length;
	while (*ptr2) {
	  ptr2++;
	}
      } else {
	status = 1;
	*ptr2++ = *ptr1++;
	*ptr2++ = *ptr1++;
      }
    } else {
      *ptr2++ = *ptr1++;
    }
  }
  *ptr2 = '\0';
  return(status);
}

/*
 * EUC ʿ̾Ҳ̾Ѵ
 */

#ifdef	__STDC__
void	euc_hira_to_kana(char *ptr1, char *ptr2)
#else	/* !__STDC__ */
void	euc_hira_to_kana(ptr1, ptr2)
     char	*ptr1;
     char	*ptr2;
#endif	/* !__STDC__ */
{
  register int	i, j;

  while (*ptr1) {
    j = 1;
    for (i = 0; i < (sizeof(trans_data) / sizeof(struct translate)); i++) {
      if (!strncmp(ptr1, trans_data[i].hiragana,
		   strlen(trans_data[i].hiragana))) {
	j = 0;
	strncpy(ptr2, trans_data[i].katakana, strlen(trans_data[i].katakana));
	ptr1 += strlen(trans_data[i].hiragana);
	ptr2 += strlen(trans_data[i].katakana);
	break;
      }
    }
    if (j) {
      if (*ptr1 & 0x80) {
	*ptr2++ = *ptr1++;
      }
      *ptr2++ = *ptr1++;
    }
  }
  *ptr2 = '\0';
}

/*
 * EUC Ҳ̾ʿ̾Ѵ
 */

#ifdef	__STDC__
void	euc_kana_to_hira(char *ptr1, char *ptr2)
#else	/* !__STDC__ */
void	euc_kana_to_hira(ptr1, ptr2)
     char	*ptr1;
     char	*ptr2;
#endif	/* !__STDC__ */
{
  register int	i, j;

  while (*ptr1) {
    j = 1;
    for (i = 0; i < (sizeof(trans_data) / sizeof(struct translate)); i++) {
      if (!strncmp(ptr1, trans_data[i].katakana,
		   strlen(trans_data[i].katakana))) {
	j = 0;
	strncpy(ptr2, trans_data[i].hiragana, strlen(trans_data[i].hiragana));
	ptr1 += strlen(trans_data[i].katakana);
	ptr2 += strlen(trans_data[i].hiragana);
	break;
      }
    }
    if (j) {
      if (*ptr1 & 0x80) {
	*ptr2++ = *ptr1++;
      }
      *ptr2++ = *ptr1++;
    }
  }
  *ptr2 = '\0';
}

/*
 * EUC ʿ̾Ҳ̾Ѵ
 */

#ifdef	__STDC__
void	euc_exchange_hira_kana(char *ptr1, char *ptr2)
#else	/* !__STDC__ */
void	euc_exchange_hira_kana(ptr1, ptr2)
     char	*ptr1;
     char	*ptr2;
#endif	/* !__STDC__ */
{
  register int	i, j;

  while (*ptr1) {
    j = 1;
    for (i = 0; i < (sizeof(trans_data) / sizeof(struct translate)); i++) {
      if (!strncmp(ptr1, trans_data[i].hiragana,
		   strlen(trans_data[i].hiragana))) {
	j = 0;
	strncpy(ptr2, trans_data[i].katakana, strlen(trans_data[i].katakana));
	ptr1 += strlen(trans_data[i].hiragana);
	ptr2 += strlen(trans_data[i].katakana);
	break;
      } else if (!strncmp(ptr1, trans_data[i].katakana,
			  strlen(trans_data[i].katakana))) {
	j = 0;
	strncpy(ptr2, trans_data[i].hiragana, strlen(trans_data[i].hiragana));
	ptr1 += strlen(trans_data[i].katakana);
	ptr2 += strlen(trans_data[i].hiragana);
	break;
      }
    }
    if (j) {
      if (*ptr1 & 0x80) {
	*ptr2++ = *ptr1++;
      }
      *ptr2++ = *ptr1++;
    }
  }
  *ptr2 = '\0';
}

/*
 * EUC ʿ̾޻Ѵ
 */

#ifdef	__STDC__
void	euc_hira_to_roma(char *ptr1, char *ptr2)
#else	/* !__STDC__ */
void	euc_hira_to_roma(ptr1, ptr2)
     char	*ptr1;
     char	*ptr2;
#endif	/* !__STDC__ */
{
  register int	i, j;

  while (*ptr1) {
    j = 1;
    for (i = 0; i < (sizeof(trans_data) / sizeof(struct translate)); i++) {
      if (!strncmp(ptr1, trans_data[i].hiragana,
		   strlen(trans_data[i].hiragana))) {
	j = 0;
	strncpy(ptr2, trans_data[i].yomi, strlen(trans_data[i].yomi));
	ptr1 += strlen(trans_data[i].hiragana);
	ptr2 += strlen(trans_data[i].yomi);
	break;
      }
    }
    if (j) {
      if (*ptr1 & 0x80) {
	*ptr2++ = *ptr1++;
      }
      *ptr2++ = *ptr1++;
    }
  }
  *ptr2 = '\0';
}

/*
 * EUC Ҳ̾޻Ѵ
 */

#ifdef	__STDC__
void	euc_kana_to_roma(char *ptr1, char *ptr2)
#else	/* !__STDC__ */
void	euc_kana_to_roma(ptr1, ptr2)
     char	*ptr1;
     char	*ptr2;
#endif	/* !__STDC__ */
{
  register int	i, j;

  while (*ptr1) {
    j = 1;
    for (i = 0; i < (sizeof(trans_data) / sizeof(struct translate)); i++) {
      if (!strncmp(ptr1, trans_data[i].katakana,
		   strlen(trans_data[i].katakana))) {
	j = 0;
	strncpy(ptr2, trans_data[i].yomi, strlen(trans_data[i].yomi));
	ptr1 += strlen(trans_data[i].katakana);
	ptr2 += strlen(trans_data[i].yomi);
	break;
      }
    }
    if (j) {
      if (*ptr1 & 0x80) {
	*ptr2++ = *ptr1++;
      }
      *ptr2++ = *ptr1++;
    }
  }
  *ptr2 = '\0';
}

/*
 * EUC ʿ̾,Ҳ̾޻Ѵ
 */

#ifdef	__STDC__
void	euc_hira_kana_to_roma(char *ptr1, char *ptr2)
#else	/* !__STDC__ */
void	euc_hira_kana_to_roma(ptr1, ptr2)
     char	*ptr1;
     char	*ptr2;
#endif	/* !__STDC__ */
{
  register int	i, j;

  while (*ptr1) {
    j = 1;
    for (i = 0; i < (sizeof(trans_data) / sizeof(struct translate)); i++) {
      if (!strncmp(ptr1, trans_data[i].hiragana,
		   strlen(trans_data[i].hiragana))) {
	j = 0;
	strncpy(ptr2, trans_data[i].yomi, strlen(trans_data[i].yomi));
	ptr1 += strlen(trans_data[i].hiragana);
	ptr2 += strlen(trans_data[i].yomi);
	break;
      } else if (!strncmp(ptr1, trans_data[i].katakana,
			  strlen(trans_data[i].katakana))) {
	j = 0;
	strncpy(ptr2, trans_data[i].yomi, strlen(trans_data[i].yomi));
	ptr1 += strlen(trans_data[i].katakana);
	ptr2 += strlen(trans_data[i].yomi);
	break;
      }
    }
    if (j) {
      if (*ptr1 & 0x80) {
	*ptr2++ = *ptr1++;
      }
      *ptr2++ = *ptr1++;
    }
  }
  *ptr2 = '\0';
}

/*
 * EUC ޻ʿ̾Ѵ
 */

#ifdef	__STDC__
void	euc_roma_to_hira(char *ptr1, char *ptr2)
#else	/* !__STDC__ */
void	euc_roma_to_hira(ptr1, ptr2)
     char	*ptr1;
     char	*ptr2;
#endif	/* !__STDC__ */
{
  register int	i, j;

  while (*ptr1) {
    j = 1;
    for (i = 0; i < (sizeof(trans_data) / sizeof(struct translate)); i++) {
      if (!strncmp(ptr1, trans_data[i].yomi, strlen(trans_data[i].yomi))) {
	j = 0;
	strncpy(ptr2, trans_data[i].hiragana, strlen(trans_data[i].hiragana));
	ptr1 += strlen(trans_data[i].yomi);
	ptr2 += strlen(trans_data[i].hiragana);
	break;
      }
    }
    if (j) {
      if (*ptr1 & 0x80) {
	*ptr2++ = *ptr1++;
      }
      *ptr2++ = *ptr1++;
    }
  }
  *ptr2 = '\0';
}

/*
 * EUC ޻Ҳ̾Ѵ
 */

#ifdef	__STDC__
void	euc_roma_to_kana(char *ptr1, char *ptr2)
#else	/* !__STDC__ */
void	euc_roma_to_kana(ptr1, ptr2)
     char	*ptr1;
     char	*ptr2;
#endif	/* !__STDC__ */
{
  register int	i, j;

  while (*ptr1) {
    j = 1;
    for (i = 0; i < (sizeof(trans_data) / sizeof(struct translate)); i++) {
      if (!strncmp(ptr1, trans_data[i].yomi,
		   strlen(trans_data[i].yomi))) {
	j = 0;
	strncpy(ptr2, trans_data[i].katakana, strlen(trans_data[i].katakana));
	ptr1 += strlen(trans_data[i].yomi);
	ptr2 += strlen(trans_data[i].katakana);
	break;
      }
    }
    if (j) {
      if (*ptr1 & 0x80) {
	*ptr2++ = *ptr1++;
      }
      *ptr2++ = *ptr1++;
    }
  }
  *ptr2 = '\0';
}

#ifdef	SUPPORT_X0201

/*
 * JIS X0201ʢX0208Ѵ
 */

#ifdef	__STDC__
void	jis_hankana_to_zen(char *ptr1, char *ptr2, int mode)
#else	/* !__STDC__ */
void	jis_hankana_to_zen(ptr1, ptr2, mode)
     char	*ptr1;
     char	*ptr2;
     int	mode;
#endif	/* !__STDC__ */
{
  char			buff[8];
  register CHARSET	charset1 = ROMAN_CHAR;
  register CHARSET	charset2 = ROMAN_CHAR;
  register CHARSET	charset3 = ROMAN_CHAR;
  register int		i;

  while (*ptr1) {
    if (*ptr1 == ESC_CODE) {
      if ((!strncmp(ptr1, JIS_IN1, 3)) || (!strncmp(ptr1, JIS_IN2, 3))) {

	/*	ؼ	*/

	charset1 = charset3 = KANJI_CHAR;
	ptr1 += 3;
      } else if (!strncmp(ptr1, JIS_IN3, 4)) {

	/*	ؼ	*/

	charset1 = charset3 = KANJI_CHAR;
	ptr1 += 4;
      } else if ((!strncmp(ptr1, JIS_OUT1, 3))
		 || (!strncmp(ptr1, JIS_OUT2, 3))) {

	/*	޻ؼ	*/

	charset1 = charset3 = ROMAN_CHAR;
	ptr1 += 3;
      } else if (!strncmp(ptr1, JIS_X0201, 3)) {

	/*	Ҳ̾ؼ	*/

	charset1 = KANJI_CHAR;
	charset3 = KANA_CHAR;
	ptr1 += 3;
      } else if (!strncmp(ptr1, JIS_X0212, 4)) {

	/*	ؼ	*/

	charset1 = charset3 = HOJO_CHAR;
	ptr1 += 4;
      } else {
	*ptr2++ = *ptr1++;
      }
    } else {
      if (charset3) {
	if (charset1 != charset2) {
	  switch (charset1) {
	  case KANA_CHAR:
	    strcpy(ptr2, JIS_X0201);
	    ptr2 += 3;
	    break;
	  case KANJI_CHAR:
	    strcpy(ptr2, jis_in);
	    ptr2 += jis_in_len;
	    break;
	  case HOJO_CHAR:
	    strcpy(ptr2, JIS_X0212);
	    ptr2 += 4;
	    break;
	  default:
	    break;
	  }
	  charset2 = charset1;
	}
	if (charset3 != KANA_CHAR) {
	  *ptr2++ = *ptr1++;
	  *ptr2++ = *ptr1++;
	} else {
	  buff[0] = (char)EUC_SS2;
	  buff[1] = *ptr1 | 0x80;
	  buff[2] = (char)EUC_SS2;
	  buff[3] = *(ptr1 + 1) | 0x80;
	  for (i = (mode ? 0 : 26);		/* 26=Ѵǿ	*/
	       i < sizeof(jisx0201_data) / sizeof(struct jisx0201); i++) {
	    if (!strncmp(buff, jisx0201_data[i].x0201,
			 strlen(jisx0201_data[i].x0201))) {
	      strcpy(ptr2, jisx0201_data[i].x0208);
	      ptr1 += (strlen(jisx0201_data[i].x0201) / 2);
	      *ptr2 = *ptr2 & 0x7F;
	      *(ptr2 + 1) = *(ptr2 + 1) & 0x7F;
	      *(ptr2 + 2) = *(ptr2 + 2) & 0x7F;
	      *(ptr2 + 3) = *(ptr2 + 3) & 0x7F;
	      ptr2 += strlen(jisx0201_data[i].x0208);
	      i = -1;
	      break;
	    }
	  }
	  if (i >= 0) {
	    *ptr2++ = *ptr1++;
	  }
	}
      } else {
	if (charset2) {
	  strcpy(ptr2, jis_out);
	  ptr2 += jis_out_len;
	  charset2 = ROMAN_CHAR;
	}
	*ptr2++ = *ptr1++;
      }
    }
  }
  if (charset2) {
    strcpy(ptr2, jis_out);
  } else {
    *ptr2 = '\0';
  }
}

/*
 * EUC X0201ʢX0208Ѵ
 */

#ifdef	__STDC__
void	euc_hankana_to_zen(char *ptr1, char *ptr2, int mode)
#else	/* !__STDC__ */
void	euc_hankana_to_zen(ptr1, ptr2, mode)
     char	*ptr1;
     char	*ptr2;
     int	mode;
#endif	/* !__STDC__ */
{
  register int	i;

  while (*ptr1) {
    if (((unsigned char)*ptr1) == EUC_SS2) {
      for (i = (mode ? 0 : 26);		/* 26=Ѵǿ	*/
	   i < sizeof(jisx0201_data) / sizeof(struct jisx0201); i++) {
	if (!strncmp(ptr1, jisx0201_data[i].x0201,
		     strlen(jisx0201_data[i].x0201))) {
	  strcpy(ptr2, jisx0201_data[i].x0208);
	  ptr1 += strlen(jisx0201_data[i].x0201);
	  ptr2 += strlen(jisx0201_data[i].x0208);
	  i = -1;
	  break;
	}
      }
      if (i >= 0) {
	*ptr2++ = *ptr1++;
	*ptr2++ = *ptr1++;
      }
    } else if (((unsigned char)*ptr1) == EUC_SS3) {
					/* 		*/
      *ptr2++ = *ptr1++;
      *ptr2++ = *ptr1++;
      *ptr2++ = *ptr1++;
    } else if (*ptr1 & 0x80) {
      *ptr2++ = *ptr1++;
      *ptr2++ = *ptr1++;
    } else {
      *ptr2++ = *ptr1++;
    }
  }
  *ptr2 = '\0';
}

/*
 * SJIS X0201ʢX0208Ѵ
 */

#ifdef	__STDC__
void	sjis_hankana_to_zen(char *ptr1, char *ptr2, int mode)
#else	/* !__STDC__ */
void	sjis_hankana_to_zen(ptr1, ptr2, mode)
     char	*ptr1;
     char	*ptr2;
     int	mode;
#endif	/* !__STDC__ */
{
  register int	i;

  while (*ptr1) {
    if ((((unsigned char)*ptr1) >= 0xa0) &&
	(((unsigned char)*ptr1) < 0xe0)) {
      *((unsigned char*)ptr2) = EUC_SS2;
      *(ptr2 + 1) = *ptr1;
      *((unsigned char*)(ptr2 + 2)) = EUC_SS2;
      *(ptr2 + 3) = *(ptr1 + 1);
      for (i = (mode ? 0 : 26);		/* 26=Ѵǿ	*/
	   i < sizeof(jisx0201_data) / sizeof(struct jisx0201); i++) {
	if (!strncmp(ptr2, jisx0201_data[i].x0201,
		     strlen(jisx0201_data[i].x0201))) {
	  euc_to_sjis(ptr2, jisx0201_data[i].x0208);
	  ptr1 += (strlen(jisx0201_data[i].x0201) / 2);
	  ptr2 += strlen(jisx0201_data[i].x0208);
	  i = -1;
	  break;
	}
      }
      if (i >= 0) {
	*ptr2++ = *ptr1++;
      }
    } else if (*ptr1 & 0x80) {
      *ptr2++ = *ptr1++;
      *ptr2++ = *ptr1++;
    } else {
      *ptr2++ = *ptr1++;
    }
  }
  *ptr2 = '\0';
}
#endif	/* SUPPORT_X0201 */
